package com.clt.io;

public interface Codepages {

    // verschiedene Textkodierungen
    public static final int MAC = 0;
    public static final int ANSI = 1;
    public static final int PC437 = 2;
    public static final int PC850 = 3; // Codeseite 850
    public static final int UNICODE = 4; // wird benutzt,
    // um RtfToken
    // mitzuteilen,
    // dass es
    // diese Zeichen auf jeden
    // Fall als Unicode
    // rausschreiben soll, und
    // fuer den
    // TextStreamReader,
    // damit er Zeichen
    // unveraendert einliest
    public static final int UNSAFE = 10; // wird aufaddiert, wenn Kodierung nicht
    // sicher ist.
    public static final int MOST_LIKELY = -1; // Benutze das wahrscheinlichste
    public static final int PLATFORM = -2; // Benutze die Plattformkodierung
    public static final int UTF8 = -3; // UTF8

    public static final char[][] ToUnicode = {
                // 0 -127 immer gleich,
                // Als Erstes: Mac -> Unicode FERTIG!
                {
                    '\u0000',
                    '\u0001',
                    '\u0002',
                    '\u0003',
                    '\u0004',
                    '\u0005',
                    '\u0006',
                    '\u0007',// 0..7
                    '\u0008',
                    '\u0009',
                    10,
                    '\u000b',
                    '\u000c',
                    13,
                    '\u000e',
                    '\u000f',// 8..15
                    '\u0010',
                    '\u0011',
                    '\u0012',
                    '\u0013',
                    '\u0014',
                    '\u0015',
                    '\u0016',
                    '\u0017',// 16..23
                    '\u0018',
                    '\u0019',
                    '\u001a',
                    '\u001b',
                    '\u001c',
                    '\u001d',
                    '\u001e',
                    '\u001f',// 24.31
                    '\u0020',
                    '\u0021',
                    '\u0022',
                    '\u0023',
                    '\u0024',
                    '\u0025',
                    '\u0026',
                    '\'', // 32..39
                    '\u0028',
                    '\u0029',
                    '\u002a',
                    '\u002b',
                    '\u002c',
                    '\u002d',
                    '\u002e',
                    '\u002f',// 40..47
                    '\u0030',
                    '\u0031',
                    '\u0032',
                    '\u0033',
                    '\u0034',
                    '\u0035',
                    '\u0036',
                    '\u0037',// 48..55
                    '\u0038',
                    '\u0039',
                    '\u003a',
                    '\u003b',
                    '\u003c',
                    '\u003d',
                    '\u003e',
                    '\u003f',// 56..63
                    '\u0040',
                    '\u0041',
                    '\u0042',
                    '\u0043',
                    '\u0044',
                    '\u0045',
                    '\u0046',
                    '\u0047',// 64..71
                    '\u0048',
                    '\u0049',
                    '\u004a',
                    '\u004b',
                    '\u004c',
                    '\u004d',
                    '\u004e',
                    '\u004f',// 72..79
                    '\u0050',
                    '\u0051',
                    '\u0052',
                    '\u0053',
                    '\u0054',
                    '\u0055',
                    '\u0056',
                    '\u0057',// 80..87
                    '\u0058',
                    '\u0059',
                    '\u005a',
                    '\u005b',
                    '\\',
                    '\u005d',
                    '\u005e',
                    '\u005f',// 88..95
                    '\u0060',
                    '\u0061',
                    '\u0062',
                    '\u0063',
                    '\u0064',
                    '\u0065',
                    '\u0066',
                    '\u0067',// 96..103
                    '\u0068',
                    '\u0069',
                    '\u006a',
                    '\u006b',
                    '\u006c',
                    '\u006d',
                    '\u006e',
                    '\u006f',// 104..111
                    '\u0070',
                    '\u0071',
                    '\u0072',
                    '\u0073',
                    '\u0074',
                    '\u0075',
                    '\u0076',
                    '\u0077',// 112..119
                    '\u0078',
                    '\u0079',
                    '\u007a',
                    '\u007b',
                    '\u007c',
                    '\u007d',
                    '\u007e',
                    '\u007f',// 120..127
                    '\u00c4',
                    '\u00c5',
                    '\u00c7',
                    '\u00c9',
                    '\u00d1',
                    '\u00d6',
                    '\u00dc',
                    '\u00e1',// 128..135
                    '\u00e0',
                    '\u00e2',
                    '\u00e4',
                    '\u00e3',
                    '\u00e5',
                    '\u00e7',
                    '\u00e9',
                    '\u00e8',// 136..143
                    '\u00ea',
                    '\u00eb',
                    '\u00ed',
                    '\u00ec',
                    '\u00ee',
                    '\u00ef',
                    '\u00f1',
                    '\u00f3',// 144..151
                    '\u00f2',
                    '\u00f4',
                    '\u00f6',
                    '\u00f5',
                    '\u00fa',
                    '\u00f9',
                    '\u00fb',
                    '\u00fc',// 152..159
                    '\u2020',
                    '\u00b0',
                    '\u00a2',
                    '\u00a3',
                    '\u00a7',
                    '\u2022',
                    '\u00b6',
                    '\u00df',// 160..167
                    '\u00ae',
                    '\u00a9',
                    '\u2122',
                    '\u00b4',
                    '\u00a8',
                    '\u2260',
                    '\u00c6',
                    '\u00d8',// 168..175
                    '\u221e',
                    '\u00b1',
                    '\u2264',
                    '\u2265',
                    '\u00a5',
                    '\u00b5',
                    '\u2202',
                    '\u03a3',// 176..183
                    '\u03a0',
                    '\u03c0',
                    '\u222b',
                    '\u00aa',
                    '\u00ba',
                    '\u03a9',
                    '\u00e6',
                    '\u00f8',// 184..191
                    '\u00bf',
                    '\u00a1',
                    '\u00ac',
                    '\u221a',
                    '\u0192',
                    '\u2248',
                    '\u2206',
                    '\u00ab',// 192..199
                    '\u00bb',
                    '\u2026',
                    '\u00a0',
                    '\u00c0',
                    '\u00c3',
                    '\u00d5',
                    '\u0152',
                    '\u0153',// 200..207
                    '\u2013', '\u2014',
                    '\u201c',
                    '\u201d',
                    '\u2018',
                    '\u2019',
                    '\u00f7',
                    '\u25c7',// 208..215
                    '\u00ff', '\u0178', '\u2044',
                    '\u00a4',
                    '\u2039',
                    '\u203a',
                    '\ufb01',
                    '\ufb02',// 216..223
                    '\u2021', '\u00b7', '\u201a', '\u201e',
                    '\u2030',
                    '\u00c2',
                    '\u00ca',
                    '\u00c1',// 224..231
                    '\u00cb', '\u00c8', '\u00cd', '\u00ce', '\u00cf',
                    '\u00cc',
                    '\u00d3',
                    '\u00d4',// 232..239
                    '\ufffd', '\u00d2', '\u00da', '\u00db', '\u00d9', '\u2081',
                    '\u0302',
                    '\u0303',// 240..247
                    '\u0304', '\u0306', '\u0307', '\u030a', '\u00b8', '\u2033', '\u0328',
                    '\u030c' // 248..255
                },
                // Jetzt: Ansi-Codepage 1252 (Windows Latin I) -> Unicode

                {
                    '\u0000',
                    '\u0001',
                    '\u0002',
                    '\u0003',
                    '\u0004',
                    '\u0005',
                    '\u0006',
                    '\u0007',// 0..7
                    '\u0008',
                    '\u0009',
                    10,
                    '\u000b',
                    '\u000c',
                    13,
                    '\u000e',
                    '\u000f',// 8..15
                    '\u0010',
                    '\u0011',
                    '\u0012',
                    '\u0013',
                    '\u0014',
                    '\u0015',
                    '\u0016',
                    '\u0017',// 16..23
                    '\u0018',
                    '\u0019',
                    '\u001a',
                    '\u001b',
                    '\u001c',
                    '\u001d',
                    '\u001e',
                    '\u001f',// 24..31
                    '\u0020',
                    '\u0021',
                    '\u0022',
                    '\u0023',
                    '\u0024',
                    '\u0025',
                    '\u0026',
                    '\'', // 32..39
                    '\u0028',
                    '\u0029',
                    '\u002a',
                    '\u002b',
                    '\u002c',
                    '\u002d',
                    '\u002e',
                    '\u002f',// 40..47
                    '\u0030',
                    '\u0031',
                    '\u0032',
                    '\u0033',
                    '\u0034',
                    '\u0035',
                    '\u0036',
                    '\u0037',// 48..55
                    '\u0038',
                    '\u0039',
                    '\u003a',
                    '\u003b',
                    '\u003c',
                    '\u003d',
                    '\u003e',
                    '\u003f',// 56..63
                    '\u0040',
                    '\u0041',
                    '\u0042',
                    '\u0043',
                    '\u0044',
                    '\u0045',
                    '\u0046',
                    '\u0047',// 64..71
                    '\u0048',
                    '\u0049',
                    '\u004a',
                    '\u004b',
                    '\u004c',
                    '\u004d',
                    '\u004e',
                    '\u004f',// 72..79
                    '\u0050',
                    '\u0051',
                    '\u0052',
                    '\u0053',
                    '\u0054',
                    '\u0055',
                    '\u0056',
                    '\u0057',// 80..87
                    '\u0058',
                    '\u0059',
                    '\u005a',
                    '\u005b',
                    '\\',
                    '\u005d',
                    '\u005e',
                    '\u005f',// 88..95
                    '\u0060',
                    '\u0061',
                    '\u0062',
                    '\u0063',
                    '\u0064',
                    '\u0065',
                    '\u0066',
                    '\u0067',// 96..103
                    '\u0068',
                    '\u0069',
                    '\u006a',
                    '\u006b',
                    '\u006c',
                    '\u006d',
                    '\u006e',
                    '\u006f',// 104..111
                    '\u0070',
                    '\u0071',
                    '\u0072',
                    '\u0073',
                    '\u0074',
                    '\u0075',
                    '\u0076',
                    '\u0077',// 112..119
                    '\u0078',
                    '\u0079',
                    '\u007a',
                    '\u007b',
                    '\u007c',
                    '\u007d',
                    '\u007e',
                    '\u007f',// 120..127
                    '\u20ac',
                    '\u0081',
                    '\u201a',
                    '\u0192',
                    '\u201e',
                    '\u2026',
                    '\u2020',
                    '\u2021',// 128..135
                    '\u02c6',
                    '\u2030',
                    '\u0160',
                    '\u2039',
                    '\u0152',
                    '\u008d',
                    '\u017d',
                    '\u008f',// 136..143
                    '\u0090',
                    '\u2018',
                    '\u2019',
                    '\u201c',
                    '\u201d',
                    '\u2022',
                    '\u2013',
                    '\u2014',// 144..151
                    '\u02dc',
                    '\u2122',
                    '\u0161',
                    '\u203a',
                    '\u0153',
                    '\u009d',
                    '\u017e',
                    '\u0178',// 152..159
                    '\u00a0',
                    '\u00a1',
                    '\u00a2',
                    '\u00a3',
                    '\u00a4',
                    '\u00a5',
                    '\u00a6',
                    '\u00a7',// 160..167
                    '\u00a8',
                    '\u00a9',
                    '\u00aa',
                    '\u00ab',
                    '\u00ac',
                    '\u00ad',
                    '\u00ae',
                    '\u00af',// 168..175
                    '\u00b0',
                    '\u00b1',
                    '\u00b2',
                    '\u00b3',
                    '\u00b4',
                    '\u00b5',
                    '\u00b6',
                    '\u00b7',// 176..183
                    '\u00b8',
                    '\u00b9',
                    '\u00ba',
                    '\u00bb',
                    '\u00bc',
                    '\u00bd',
                    '\u00be',
                    '\u00bf',// 184..191
                    '\u00c0',
                    '\u00c1',
                    '\u00c2',
                    '\u00c3',
                    '\u00c4',
                    '\u00c5',
                    '\u00c6',
                    '\u00c7',// 192..199
                    '\u00c8',
                    '\u00c9',
                    '\u00ca',
                    '\u00cb',
                    '\u00cc',
                    '\u00cd',
                    '\u00ce',
                    '\u00cf',// 200..207
                    '\u00d0', '\u00d1',
                    '\u00d2',
                    '\u00d3',
                    '\u00d4',
                    '\u00d5',
                    '\u00d6',
                    '\u00d7',// 208..215
                    '\u00d8', '\u00d9', '\u00da',
                    '\u00db',
                    '\u00dc',
                    '\u00dd',
                    '\u00de',
                    '\u00df',// 216..223
                    '\u00e0', '\u00e1', '\u00e2', '\u00e3',
                    '\u00e4',
                    '\u00e5',
                    '\u00e6',
                    '\u00e7',// 224..231
                    '\u00e8', '\u00e9', '\u00ea', '\u00eb', '\u00ec',
                    '\u00ed',
                    '\u00ee',
                    '\u00ef',// 232..239
                    '\u00f0', '\u00f1', '\u00f2', '\u00f3', '\u00f4', '\u00f5',
                    '\u00f6',
                    '\u00f7',// 240..247
                    '\u00f8', '\u00f9', '\u00fa', '\u00fb', '\u00fc', '\u00fd', '\u00fe',
                    '\u00ff' // 248..255
                },
                // PC-Codeseite 437 -> Unicode
                {
                    '\u0000',
                    '\u0001',
                    '\u0002',
                    '\u0003',
                    '\u0004',
                    '\u0005',
                    '\u0006',
                    '\u0007',// 0..7
                    '\u0008',
                    '\u0009',
                    10,
                    '\u000b',
                    '\u000c',
                    13,
                    '\u000e',
                    '\u000f',// 8..15
                    '\u0010',
                    '\u0011',
                    '\u0012',
                    '\u0013',
                    '\u0014',
                    '\u0015',
                    '\u0016',
                    '\u0017',// 16..23
                    '\u0018',
                    '\u0019',
                    '\u001a',
                    '\u001b',
                    '\u001c',
                    '\u001d',
                    '\u001e',
                    '\u001f',// 24..31
                    '\u0020',
                    '\u0021',
                    '\u0022',
                    '\u0023',
                    '\u0024',
                    '\u0025',
                    '\u0026',
                    '\'', // 32..39
                    '\u0028',
                    '\u0029',
                    '\u002a',
                    '\u002b',
                    '\u002c',
                    '\u002d',
                    '\u002e',
                    '\u002f',// 40..47
                    '\u0030',
                    '\u0031',
                    '\u0032',
                    '\u0033',
                    '\u0034',
                    '\u0035',
                    '\u0036',
                    '\u0037',// 48..55
                    '\u0038',
                    '\u0039',
                    '\u003a',
                    '\u003b',
                    '\u003c',
                    '\u003d',
                    '\u003e',
                    '\u003f',// 56..63
                    '\u0040',
                    '\u0041',
                    '\u0042',
                    '\u0043',
                    '\u0044',
                    '\u0045',
                    '\u0046',
                    '\u0047',// 64..71
                    '\u0048',
                    '\u0049',
                    '\u004a',
                    '\u004b',
                    '\u004c',
                    '\u004d',
                    '\u004e',
                    '\u004f',// 72..79
                    '\u0050',
                    '\u0051',
                    '\u0052',
                    '\u0053',
                    '\u0054',
                    '\u0055',
                    '\u0056',
                    '\u0057',// 80..87
                    '\u0058',
                    '\u0059',
                    '\u005a',
                    '\u005b',
                    '\\',
                    '\u005d',
                    '\u005e',
                    '\u005f',// 88..95
                    '\u0060',
                    '\u0061',
                    '\u0062',
                    '\u0063',
                    '\u0064',
                    '\u0065',
                    '\u0066',
                    '\u0067',// 96..103
                    '\u0068',
                    '\u0069',
                    '\u006a',
                    '\u006b',
                    '\u006c',
                    '\u006d',
                    '\u006e',
                    '\u006f',// 104..111
                    '\u0070',
                    '\u0071',
                    '\u0072',
                    '\u0073',
                    '\u0074',
                    '\u0075',
                    '\u0076',
                    '\u0077',// 112..119
                    '\u0078',
                    '\u0079',
                    '\u007a',
                    '\u007b',
                    '\u007c',
                    '\u007d',
                    '\u007e',
                    '\u007f',// 120..127
                    '\u00c7',
                    '\u00fc',
                    '\u00e9',
                    '\u00e2',
                    '\u00e4',
                    '\u00e0',
                    '\u00e5',
                    '\u00e7',// 128..135
                    '\u00ea',
                    '\u00eb',
                    '\u00e8',
                    '\u00ef',
                    '\u00ee',
                    '\u00ec',
                    '\u00c4',
                    '\u00c5',// 136..143
                    '\u00c9',
                    '\u00e6',
                    '\u00c6',
                    '\u00f4',
                    '\u00f6',
                    '\u00f2',
                    '\u00fb',
                    '\u00f9',// 144..151
                    '\u00ff',
                    '\u00d6',
                    '\u00dc',
                    '\u00a2',
                    '\u00a3',
                    '\u00a5',
                    '\u20a7',
                    '\u0192',// 152..159
                    '\u00e1',
                    '\u00ed',
                    '\u00f3',
                    '\u00fa',
                    '\u00f1',
                    '\u00d1',
                    '\u00aa',
                    '\u00ba',// 160..167
                    '\u00bf',
                    '\u250c',
                    '\u00ac',
                    '\u00bd',
                    '\u00bc',
                    '\u00a1',
                    '\u00ab',
                    '\u00bb',// 168..175
                    '\u2592',
                    '\u2591',
                    '\u2593',
                    '\u2502',
                    '\u2524',
                    '\u2561',
                    '\u2562',
                    '\u2556',// 176..183
                    '\u2555',
                    '\u2563',
                    '\u2551',
                    '\u2557',
                    '\u255d',
                    '\u255c',
                    '\u255b',
                    '\u2510',// 184..191
                    '\u2514',
                    '\u2534',
                    '\u252c',
                    '\u251c',
                    '\u2500',
                    '\u253c',
                    '\u255e',
                    '\u255f',// 192..199
                    '\u255a',
                    '\u2554',
                    '\u2569',
                    '\u2566',
                    '\u2560',
                    '\u2550',
                    '\u256c',
                    '\u2567',// 200..207
                    '\u2568', '\u2564',
                    '\u2565',
                    '\u2559',
                    '\u2558',
                    '\u2552',
                    '\u2553',
                    '\u256b',// 208..215
                    '\u256a',
                    '\u2518',
                    '\u250c',
                    '\u2588',
                    '\u2584',
                    '\u258c',
                    '\u2590',
                    '\u2580',// 216..223
                    // '\u03b1','\u03b2','\u0393','\u03c0','\u03a3','\u03c3','\u03bc','\u03c4',//224..231
                    '\u03b1', '\u00df', '\u0393', '\u03c0',
                    '\u03a3',
                    '\u03c3',
                    '\u03bc',
                    '\u03c4',// 224..231
                    '\u03a6', '\u03b8', '\u03a9', '\u03b4', '\u221e',
                    '\u00f8',
                    '\u220a',
                    '\u2229',// 232..239
                    '\u2261', '\u00b1', '\u2265', '\u2264', '\u2320', '\u2321',
                    '\u00f7',
                    '\u2248',// 240..247
                    '\u00b0', '\u00b7', '\u00b7', '\u221a', '\u207f', '\u00b2', '\u220e',
                    '\u00a0' // 248..255
                },
                // PC-Codeseite 850 -> Unicode
                {
                    '\u0000',
                    '\u0001',
                    '\u0002',
                    '\u0003',
                    '\u0004',
                    '\u0005',
                    '\u0006',
                    '\u0007',// 0..7
                    '\u0008',
                    '\u0009',
                    10,
                    '\u000b',
                    '\u000c',
                    13,
                    '\u000e',
                    '\u000f',// 8..15
                    '\u0010',
                    '\u0011',
                    '\u0012',
                    '\u0013',
                    '\u0014',
                    '\u0015',
                    '\u0016',
                    '\u0017',// 16..23
                    '\u0018',
                    '\u0019',
                    '\u001a',
                    '\u001b',
                    '\u001c',
                    '\u001d',
                    '\u001e',
                    '\u001f',// 24..31
                    '\u0020',
                    '\u0021',
                    '\u0022',
                    '\u0023',
                    '\u0024',
                    '\u0025',
                    '\u0026',
                    '\'', // 32..39
                    '\u0028',
                    '\u0029',
                    '\u002a',
                    '\u002b',
                    '\u002c',
                    '\u002d',
                    '\u002e',
                    '\u002f',// 40..47
                    '\u0030',
                    '\u0031',
                    '\u0032',
                    '\u0033',
                    '\u0034',
                    '\u0035',
                    '\u0036',
                    '\u0037',// 48..55
                    '\u0038',
                    '\u0039',
                    '\u003a',
                    '\u003b',
                    '\u003c',
                    '\u003d',
                    '\u003e',
                    '\u003f',// 56..63
                    '\u0040',
                    '\u0041',
                    '\u0042',
                    '\u0043',
                    '\u0044',
                    '\u0045',
                    '\u0046',
                    '\u0047',// 64..71
                    '\u0048',
                    '\u0049',
                    '\u004a',
                    '\u004b',
                    '\u004c',
                    '\u004d',
                    '\u004e',
                    '\u004f',// 72..79
                    '\u0050',
                    '\u0051',
                    '\u0052',
                    '\u0053',
                    '\u0054',
                    '\u0055',
                    '\u0056',
                    '\u0057',// 80..87
                    '\u0058',
                    '\u0059',
                    '\u005a',
                    '\u005b',
                    '\\',
                    '\u005d',
                    '\u005e',
                    '\u005f',// 88..95
                    '\u0060',
                    '\u0061',
                    '\u0062',
                    '\u0063',
                    '\u0064',
                    '\u0065',
                    '\u0066',
                    '\u0067',// 96..103
                    '\u0068',
                    '\u0069',
                    '\u006a',
                    '\u006b',
                    '\u006c',
                    '\u006d',
                    '\u006e',
                    '\u006f',// 104..111
                    '\u0070',
                    '\u0071',
                    '\u0072',
                    '\u0073',
                    '\u0074',
                    '\u0075',
                    '\u0076',
                    '\u0077',// 112..119
                    '\u0078',
                    '\u0079',
                    '\u007a',
                    '\u007b',
                    '\u007c',
                    '\u007d',
                    '\u007e',
                    '\u007f',// 120..127
                    '\u00c7', '\u00fc', '\u00e9', '\u00e2', '\u00e4', '\u00e0',
                    '\u00e5',
                    '\u00e7',
                    '\u00ea', '\u00eb', '\u00e8', '\u00ef', '\u00ee', '\u00ec',
                    '\u00c4', '\u00c5',
                    '\u00c9', '\u00e6', '\u00c6', '\u00f4', '\u00f6', '\u00f2',
                    '\u00fb', '\u00f9',
                    '\u00ff', '\u00d6', '\u00dc', '\u00f8', '\u00a3', '\u00d8',
                    '\u2573', '\u0192',
                    '\u00e1', '\u00ed', '\u00f3', '\u00fa', '\u00f1', '\u00d1',
                    '\u00aa', '\u00ba',
                    '\u00bf', '\u00ae', '\u00ac', '\u00bd', '\u00bc', '\u00a1',
                    '\u00ab', '\u00bb',
                    '\u2591', '\u2592', '\u2593', '\u2502', '\u2524', '\u00c1',
                    '\u00c2', '\u00c0',
                    '\u00a9', '\u2563', '\u2551', '\u2557', '\u255d', '\u00a2',
                    '\u00a5', '\u2510',
                    '\u2514', '\u2534', '\u252c', '\u251c', '\u2500', '\u253c',
                    '\u00e3', '\u00c3',
                    '\u255a', '\u2554', '\u2569', '\u2566', '\u2560', '\u2550',
                    '\u256c', '\u00a4',
                    '\u00f0', '\u00d0', '\u00c9', '\u00cb', '\u00c8', '\u00b9',
                    '\u00cd', '\u00ce',
                    '\u00cf', '\u2518', '\u250c', '\u2588', '\u2584', '\u00a6',
                    '\u00cc', '\u2580',
                    '\u00d3', '\u00df', '\u00d4', '\u00d2', '\u00f5', '\u00d5',
                    '\u00b5', '\u00fe',
                    '\u00de', '\u00da', '\u00db', '\u00d9', '\u00fd', '\u00dd',
                    '\u00af', '\u00b4',
                    '\u2015', '\u00b1', '\u2017', '\u00be', '\u00b6', '\u00a7',
                    '\u00f7', '\u00b8',
                    '\u00b0', '\u00a8', '\u00b7', '\u00b9', '\u00b3', '\u00b2',
                    '\u25a0', '\u00a0'},
                // Unicode -> Unicode, macht gar nix, bildet jeden Wert auf sich
                // selber ab.
                // Wird u.a. von TextStreamReader benutzt, um Zeichen unveraendert
                // einzulesen.
                {
                    '\u0000',
                    '\u0001',
                    '\u0002',
                    '\u0003',
                    '\u0004',
                    '\u0005',
                    '\u0006',
                    '\u0007',// 0..7
                    '\u0008',
                    '\u0009',
                    10,
                    '\u000b',
                    '\u000c',
                    13,
                    '\u000e',
                    '\u000f',// 8..15
                    '\u0010',
                    '\u0011',
                    '\u0012',
                    '\u0013',
                    '\u0014',
                    '\u0015',
                    '\u0016',
                    '\u0017',// 16..23
                    '\u0018',
                    '\u0019',
                    '\u001a',
                    '\u001b',
                    '\u001c',
                    '\u001d',
                    '\u001e',
                    '\u001f',// 24..31
                    '\u0020',
                    '\u0021',
                    '\u0022',
                    '\u0023',
                    '\u0024',
                    '\u0025',
                    '\u0026',
                    '\'', // 32..39
                    '\u0028',
                    '\u0029',
                    '\u002a',
                    '\u002b',
                    '\u002c',
                    '\u002d',
                    '\u002e',
                    '\u002f',// 40..47
                    '\u0030',
                    '\u0031',
                    '\u0032',
                    '\u0033',
                    '\u0034',
                    '\u0035',
                    '\u0036',
                    '\u0037',// 48..55
                    '\u0038',
                    '\u0039',
                    '\u003a',
                    '\u003b',
                    '\u003c',
                    '\u003d',
                    '\u003e',
                    '\u003f',// 56..63
                    '\u0040',
                    '\u0041',
                    '\u0042',
                    '\u0043',
                    '\u0044',
                    '\u0045',
                    '\u0046',
                    '\u0047',// 64..71
                    '\u0048',
                    '\u0049',
                    '\u004a',
                    '\u004b',
                    '\u004c',
                    '\u004d',
                    '\u004e',
                    '\u004f',// 72..79
                    '\u0050',
                    '\u0051',
                    '\u0052',
                    '\u0053',
                    '\u0054',
                    '\u0055',
                    '\u0056',
                    '\u0057',// 80..87
                    '\u0058',
                    '\u0059',
                    '\u005a',
                    '\u005b',
                    '\\',
                    '\u005d',
                    '\u005e',
                    '\u005f',// 88..95
                    '\u0060',
                    '\u0061',
                    '\u0062',
                    '\u0063',
                    '\u0064',
                    '\u0065',
                    '\u0066',
                    '\u0067',// 96..103
                    '\u0068',
                    '\u0069',
                    '\u006a',
                    '\u006b',
                    '\u006c',
                    '\u006d',
                    '\u006e',
                    '\u006f',// 104..111
                    '\u0070',
                    '\u0071',
                    '\u0072',
                    '\u0073',
                    '\u0074',
                    '\u0075',
                    '\u0076',
                    '\u0077',// 112..119
                    '\u0078',
                    '\u0079',
                    '\u007a',
                    '\u007b',
                    '\u007c',
                    '\u007d',
                    '\u007e',
                    '\u007f',// 120..127
                    '\u0080', '\u0081', '\u0082', '\u0083', '\u0084', '\u0085',
                    '\u0086',
                    '\u0087',
                    '\u0088', '\u0089', '\u008a', '\u008b', '\u008c', '\u008d',
                    '\u008e', '\u008f',
                    '\u0090', '\u0091', '\u0092', '\u0093', '\u0094', '\u0095',
                    '\u0096', '\u0097',
                    '\u0098', '\u0099', '\u009a', '\u009b', '\u009c', '\u009d',
                    '\u009e', '\u009f',
                    '\u00a0', '\u00a1', '\u00a2', '\u00a3', '\u00a4', '\u00a5',
                    '\u00a6', '\u00a7',
                    '\u00a8', '\u00a9', '\u00aa', '\u00ab', '\u00ac', '\u00ad',
                    '\u00ae', '\u00af',
                    '\u00b0', '\u00b1', '\u00b2', '\u00b3', '\u00b4', '\u00b5',
                    '\u00b6', '\u00b7',
                    '\u00b8', '\u00b9', '\u00ba', '\u00bb', '\u00bc', '\u00bd',
                    '\u00be', '\u00bf',
                    '\u00c0', '\u00c1', '\u00c2', '\u00c3', '\u00c4', '\u00c5',
                    '\u00c6', '\u00c7',
                    '\u00c8', '\u00c9', '\u00ca', '\u00cb', '\u00cc', '\u00cd',
                    '\u00ce', '\u00cf',
                    '\u00d0', '\u00d1', '\u00d2', '\u00d3', '\u00d4', '\u00d5',
                    '\u00d6', '\u00d7',
                    '\u00d8', '\u00d9', '\u00da', '\u00db', '\u00dc', '\u00dd',
                    '\u00de', '\u00df',
                    '\u00e0', '\u00e1', '\u00e2', '\u00e3', '\u00e4', '\u00e5',
                    '\u00e6', '\u00e7',
                    '\u00e8', '\u00e9', '\u00ea', '\u00eb', '\u00ec', '\u00ed',
                    '\u00ee', '\u00ef',
                    '\u00f0', '\u00f1', '\u00f2', '\u00f3', '\u00f4', '\u00f5',
                    '\u00f6', '\u00f7',
                    '\u00f8', '\u00f9', '\u00fa', '\u00fb', '\u00fc', '\u00fd',
                    '\u00fe', '\u00ff'}};

    /*
   * public String[] SprachenNamen = { "No language", "Albanian", "Arabic",
   * "Bahasa", "Belgian Dutch", "Belgian French", "Brazilian Portuguese",
   * "Bulgarian", "Catalan", "Croato-Serbian (Latin)", "Czech", "Danish",
   * "Dutch", "English (Australian)", "English (U.K.)", "English (U.S.)",
   * "Finnish", "French", "French (Canadian)", "German", "Greek", "Hebrew",
   * "Hungarian", "Icelandic", "Italian", "Japanese", "Korean", "Norwegian
   * (Bokmal)", "Norwegian (Nynorsk)", "Polish", "Portuguese", "Rhaeto-Romanic",
   * "Romanian", "Russian", "Serbo-Croatian (Cyrillic)", "Simplified Chinese",
   * "Slovak", "Spanish (Castilian)", "Spanish (Mexican)", "Swedish", "Swiss
   * French", "Swiss German", "Swiss Italian", "Thai", "Traditional Chinese",
   * "Turkish", "Urdu", "Sesotho (Sotho)", "Afrikaans", "Zulu", "Xhosa",
   * "Venda", "Tswana", "Tsonga", "Farsi (Persian)" }; public final static int[]
   * SprachenNummern = { 0x0400, 0x041c, 0x0401, 0x0421, 0x0813, 0x080c, 0x0416,
   * 0x0402, 0x0403, 0x041a, 0x0405, 0x0406, 0x0413, 0x0c09, 0x0809, 0x0409,
   * 0x040b, 0x040c, 0x0c0c, 0x0407, 0x0408, 0x040d, 0x040e, 0x040f, 0x0410,
   * 0x0411, 0x0412, 0x0414, 0x0814, 0x0415, 0x0816, 0x0417, 0x0418, 0x0419,
   * 0x081a, 0x0804, 0x041b, 0x040a, 0x080a, 0x041d, 0x100c, 0x0807, 0x0810,
   * 0x041e, 0x0404, 0x041f, 0x0420, 0x0430, 0x0436, 0x0435, 0x0434, 0x0433,
   * 0x0432, 0x0431, 0x0429 };
     */
    public final static int No_language = 0x0400, Albanian = 0x041c,
            Arabic = 0x0401,
            Bahasa = 0x0421, Belgian_Dutch = 0x0813, Belgian_French = 0x080c,
            Brazilian_Portuguese = 0x0416, Bulgarian = 0x0402,
            Catalan = 0x0403,
            Croato_Serbian_Latin = 0x041a, Czech = 0x0405, Danish = 0x0406,
            Dutch = 0x0413,
            English_Australian = 0x0c09, English_UK = 0x0809,
            English_US = 0x0409,
            Finnish = 0x040b, French = 0x040c, French_Canadian = 0x0c0c,
            German = 0x0407,
            Greek = 0x0408, Hebrew = 0x040d, Hungarian = 0x040e,
            Icelandic = 0x040f,
            Italian = 0x0410, Japanese = 0x0411, Korean = 0x0412,
            Norwegian_Bokmal = 0x0414,
            Norwegian_Nynorsk = 0x0814, Polish = 0x0415, Portuguese = 0x0816,
            Rhaeto_Romanic = 0x0417, Romanian = 0x0418, Russian = 0x0419,
            Serbo_Croatian_Cyrillic = 0x081a, Simplified_Chinese = 0x0804,
            Slovak = 0x041b,
            Spanish_Castilian = 0x040a, Spanish_Mexican = 0x080a,
            Swedish = 0x041d,
            Swiss_French = 0x100c, Swiss_German = 0x0807,
            Swiss_Italian = 0x0810, Thai = 0x041e,
            Traditional_Chinese = 0x0404, Turkish = 0x041f, Urdu = 0x0420,
            Sesotho_Sotho = 0x0430,
            Afrikaans = 0x0436, Zulu = 0x0435, Xhosa = 0x0434, Venda = 0x0433,
            Tswana = 0x0432,
            Tsonga = 0x0431, Farsi_Persian = 0x0429;
}
